SystemOrganization addCategory: #'Mars-Cocoa-Base'!
SystemOrganization addCategory: #'Mars-Cocoa-View'!
SystemOrganization addCategory: #'Mars-Cocoa-Delegate'!

!Point methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/21/2012 17:03'!
translateToFirstQuadrant
	| size |
	size := (Rectangle fromNSRect: ('NSScreen' inObjectiveC mainScreen frame)) corner.
	^self class 
		x: self x
		y: size y - self y	
	! !

!Point methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/21/2012 17:08'!
translateToFourthQuadrant
	| size |
	size := (Rectangle fromNSRect: ('NSScreen' inObjectiveC mainScreen frame)) corner.
	^self class 
		x: self x
		y: size y - self y! !

!String class methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/21/2012 15:26'!
fromNSString: aNSString
	^aNSString UTF8String strcpy! !

!Rectangle class methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/21/2012 15:29'!
fromNSRect: anAlien
	^self 
		origin: (anAlien floatAt: 1) asInteger@(anAlien floatAt: 5) asInteger
		extent: (anAlien floatAt: 9) asInteger@(anAlien floatAt: 13) asInteger! !

!Rectangle methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/21/2012 15:29'!
asNSRect
	self flag: #todo. "This should be a plain alien (I don't want to have a NS objects pollution)"
	^NSRect 
		x: self left
		y: self top
		width: self width 
		height: self height! !

!Rectangle methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/21/2012 17:15'!
translateToFirstQuadrant 
	^self class
		origin: self origin translateToFirstQuadrant - (0@self height)
		extent: self extent! !

!Rectangle methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/21/2012 17:15'!
translateToFourthQuadrant 
	^self class
		origin: self origin translateToFourthQuadrant + (0@self height)
		extent: self extent! !

!Boolean class methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/21/2012 15:34'!
fromNumber: aNumber
	^aNumber == 1! !

Object subclass: #CocoaApplication
	instanceVariableNames: 'registeredWindows'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'Mars-Cocoa-Base'!

!CocoaApplication class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:21'!
current 
	^Current ifNil: [ self run ]! !

!CocoaApplication class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:21'!
new
	self error: 'Invalid invocation, my subclasses should be executed by calling #run'! !

!CocoaApplication class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:21'!
reset 
	Current := nil.! !

!CocoaApplication class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:21'!
run
	Current ifNotNil: [ self reset ].
	Current := super new.
	Current run.
	^Current! !

!CocoaApplication methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:21'!
initialize
	super initialize.
	registeredWindows := Set new.! !

!CocoaApplication methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:21'!
registerWindow: aWindow
	registeredWindows add: aWindow.! !

!CocoaApplication methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:22'!
run! !

!CocoaApplication methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:22'!
unregisterWindow: aWindow
	registeredWindows remove: aWindow.
	"Ensure window is released (all memory is released)"
	aWindow release.! !

Object subclass: #CocoaAutoreleasePool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-Base'!

CocoaAutoreleasePool class
	instanceVariableNames: 'pool count'!

CocoaAutoreleasePool class
	instanceVariableNames: 'pool count'!

!CocoaAutoreleasePool class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 15:27'!
do: aBlock 
	[ self init. 
	  ^aBlock value ]
	ensure: [ self release ]  ! !

!CocoaAutoreleasePool class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 15:27'!
init 
	count ifNil: [ count := 0 ].
	count = 0 ifTrue: [
		count := count + 1.
		pool := 'NSAutoreleasePool' inObjectiveC alloc init ].
	! !

!CocoaAutoreleasePool class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 15:27'!
release
	count := count - 1.
	count = 0 ifTrue: [
 		pool drain.
		pool := nil.
		count := nil ]! !

Object subclass: #CocoaDelegate
	instanceVariableNames: 'owner proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-Delegate'!

!CocoaDelegate class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/21/2012 15:59'!
for: anObject
	^self basicNew 
		initialize: anObject;
		yourself! !

!CocoaDelegate class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/21/2012 15:59'!
new 
	self error: 'Use #for:'! !

!CocoaDelegate methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 16:00'!
externalHandle 
	^proxy proxy! !

!CocoaDelegate methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/21/2012 16:00'!
initialize 
	super initialize.
	proxy := ObjectiveCSmalltalkProxyClass instanceFor: self! !

!CocoaDelegate methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/21/2012 15:58'!
initialize: aView
	owner := aView.
	self initialize.! !

!CocoaDelegate methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:58'!
owner 
	^owner! !

CocoaDelegate subclass: #CocoaWindowDelegate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-Delegate'!

!CocoaWindowDelegate methodsFor: 'delegates' stamp: 'EstebanLorenzano 1/21/2012 16:06'!
"(BOOL)"windowShouldClose:"(id)"sender
	<objectiveCSignature: 'i@:@'>	
	^true asAlien! !

!CocoaWindowDelegate methodsFor: 'delegates' stamp: 'EstebanLorenzano 1/21/2012 16:23'!
"(void)"windowWillClose:"(NSNotification *)"notification
	<objectiveCSignature: 'v@:@'>
	self owner unregister.
	^nil asAlien! !

SharedPool subclass: #CocoaConstantPool
	instanceVariableNames: ''
	classVariableNames: 'NSAlertFirstButtonReturn NSAlertSecondButtonReturn NSAlertThirdButtonReturn NSAlphaShiftKeyMask NSAlternateKeyMask NSBackingStoreBuffered NSBackingStoreNonretained NSBackingStoreRetained NSBezelBorder NSBoldFontMask NSBorderlessWindowMask NSCircularBezelStyle NSClosableWindowMask NSCommandKeyMask NSCompressedFontMask NSCondensedFontMask NSControlKeyMask NSCriticalAlertStyle NSDeviceIndependentModifierFlagsMask NSDisclosureBezelStyle NSExpandedFontMask NSFixedPitchFontMask NSFunctionKeyMask NSGrooveBorder NSHelpButtonBezelStyle NSHelpKeyMask NSHighlightModeMatrix NSImageAbove NSImageBelow NSImageCellType NSImageLeft NSImageOnly NSImageOverlaps NSImageRight NSInformationalAlertStyle NSItalicFontMask NSLineBorder NSListModeMatrix NSMiniaturizableWindowMask NSMixedState NSMomentaryChangeButton NSMomentaryLight NSMomentaryLightButton NSMomentaryPushButton NSMomentaryPushInButton NSNarrowFontMask NSNoBorder NSNoImage NSNonStandardCharacterSetFontMask NSNotFound NSNullCellType NSNumericPadKeyMask NSOffState NSOnOffButton NSOnState NSPosterFontMask NSPushOnPushOffButton NSRadioButton NSRadioModeMatrix NSRecessedBezelStyle NSRegularSquareBezelStyle NSResizableWindowMask NSRoundRectBezelStyle NSRoundedBezelStyle NSRoundedDisclosureBezelStyle NSScaleNone NSScaleProportionally NSScaleToFit NSSegmentStyleAutomatic NSSegmentStyleCapsule NSSegmentStyleRoundRect NSSegmentStyleRounded NSSegmentStyleSmallSquare NSSegmentStyleTexturedRounded NSSegmentStyleTexturedSquare NSShadowlessSquareBezelStyle NSShiftKeyMask NSSmallCapsFontMask NSSmallSquareBezelStyle NSSplitViewDividerStylePaneSplitter NSSplitViewDividerStyleThick NSSplitViewDividerStyleThin NSSwitchButton NSTableViewFirstColumnOnlyAutoresizingStyle NSTableViewLastColumnOnlyAutoresizingStyle NSTableViewNoColumnAutoresizing NSTableViewReverseSequentialColumnAutoresizingStyle NSTableViewSequentialColumnAutoresizingStyle NSTableViewUniformColumnAutoresizingStyle NSTextCellType NSTextFieldRoundedBezel NSTextFieldSquareBezel NSTexturedBackgroundWindowMask NSTexturedRoundedBezelStyle NSTexturedSquareBezelStyle NSThickSquareBezelStyle NSThickerSquareBezelStyle NSTitledWindowMask NSToggleButton NSToolbarDisplayModeDefault NSToolbarDisplayModeIconAndLabel NSToolbarDisplayModeIconOnly NSToolbarDisplayModeLabelOnly NSToolbarSizeModeDefault NSToolbarSizeModeRegular NSToolbarSizeModeSmall NSTrackModeMatrix NSUnboldFontMask NSUnitalicFontMask NSViewHeightSizable NSViewMaxXMargin NSViewMaxYMargin NSViewMinXMargin NSViewMinYMargin NSViewNotSizable NSViewWidthSizable NSWarningAlertStyle NSWindowCloseButton NSWindowDocumentIconButton NSWindowMiniaturizeButton NSWindowToolbarButton NSWindowZoomButton'
	poolDictionaries: ''
	category: 'Mars-Cocoa-Base'!

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initialize
	super initialize.
	self initializeConstants.! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeButtonConstants 
! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeCellConstants 
	"Cell Types"
	NSNullCellType  := 0.
   	NSTextCellType  := 1.
   	NSImageCellType := 2.! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeConstants
 	"self initializeConstants"
	self initializeWindowConstants.
  	self initializeLayoutConstants. 	
	self initializeWidgetConstants.
	self initializeCellConstants.
	self initializeToolbarConstants.
	self initializeMenuConstants.
	self initializeErrorConstants.
	self initializeFontConstants.! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeErrorConstants 
	"NSError codes"
	NSNotFound := 16r7FFFFFFF.
! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeFontConstants 
	"Font traits"
	NSItalicFontMask 			:= 16r00000001.
  	NSBoldFontMask 			:= 16r00000002.
   	NSUnboldFontMask 		:= 16r00000004.
   	NSNonStandardCharacterSetFontMask 	:= 16r00000008.
   	NSNarrowFontMask 		:= 16r00000010.
   	NSExpandedFontMask 		:= 16r00000020.
   	NSCondensedFontMask 	:= 16r00000040.
   	NSSmallCapsFontMask 		:= 16r00000080.
   	NSPosterFontMask 			:= 16r00000100.
   	NSCompressedFontMask 	:= 16r00000200.
   	NSFixedPitchFontMask 		:= 16r00000400.
   	NSUnitalicFontMask 		:= 16r01000000.
! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeLayoutConstants
	"Layout constants"
    	NSViewNotSizable								:= 0.
    	NSViewMinXMargin								:= 1.
    	NSViewWidthSizable							:= 2.
    	NSViewMaxXMargin								:= 4.
    	NSViewMinYMargin								:= 8.
    	NSViewHeightSizable							:= 16.
    	NSViewMaxYMargin								:= 32.
	"Table autoresizing options"
 	NSTableViewNoColumnAutoresizing 				:= 0.
   	NSTableViewUniformColumnAutoresizingStyle 		:= 1.
   	NSTableViewSequentialColumnAutoresizingStyle 	:= 2.
   	NSTableViewReverseSequentialColumnAutoresizingStyle := 3.
   	NSTableViewLastColumnOnlyAutoresizingStyle 	:= 4.
   	NSTableViewFirstColumnOnlyAutoresizingStyle 	:= 5.
	! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeMenuConstants 
	"Key masks (for menus)"
	NSAlphaShiftKeyMask := 1 << 16.
	NSShiftKeyMask := 1 << 17.
	NSControlKeyMask := 1 << 18.
	NSAlternateKeyMask := 1 << 19.
	NSCommandKeyMask := 1 << 20.
	NSNumericPadKeyMask := 1 << 21.
	NSHelpKeyMask := 1 << 22.
	NSFunctionKeyMask := 1 << 23.
	NSDeviceIndependentModifierFlagsMask := 16rFFFF0000	! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeToolbarConstants 
	"Toolbar display types"
 	NSToolbarDisplayModeDefault := 0.
	NSToolbarDisplayModeIconAndLabel := 1.
	NSToolbarDisplayModeIconOnly := 2.
	NSToolbarDisplayModeLabelOnly := 3.
	"Size modes"
 	NSToolbarSizeModeDefault := 0.
   	NSToolbarSizeModeRegular := 1.
   	NSToolbarSizeModeSmall := 2.
! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeWidgetConstants 
	"Button states"
	NSOffState := 0.
	NSOnState := 1.
	NSMixedState := -1.
	"Bezel types"
 	NSRoundedBezelStyle           	:= 1.
   	NSRegularSquareBezelStyle     	:= 2.
   	NSThickSquareBezelStyle       	:= 3.
   	NSThickerSquareBezelStyle     	:= 4.
   	NSDisclosureBezelStyle        	:= 5.
   	NSShadowlessSquareBezelStyle  := 6.
   	NSCircularBezelStyle          		:= 7.
   	NSTexturedSquareBezelStyle   := 8.
   	NSHelpButtonBezelStyle        	:= 9.
   	NSSmallSquareBezelStyle       	:= 10.
   	NSTexturedRoundedBezelStyle := 11.
   	NSRoundRectBezelStyle         	:= 12.
   	NSRecessedBezelStyle          	:= 13.
   	NSRoundedDisclosureBezelStyle := 14.
	"Button types"
   	NSMomentaryLightButton   		:= 0.
   	NSPushOnPushOffButton    		:= 1.
   	NSToggleButton           			:= 2.
   	NSSwitchButton           			:= 3.
   	NSRadioButton            			:= 4.
   	NSMomentaryChangeButton 	:= 5.
   	NSOnOffButton            			:= 6.
   	NSMomentaryPushInButton  	:= 7.
   	NSMomentaryPushButton    	:= 0.
   	NSMomentaryLight         		:= 7.
	"Matrix states"
	NSRadioModeMatrix := 0.
   	NSHighlightModeMatrix := 1.
   	NSListModeMatrix := 2.
   	NSTrackModeMatrix := 3.
	"Borders"
	NSNoBorder := 0.
   	NSLineBorder := 1.
   	NSBezelBorder := 2.
   	NSGrooveBorder := 3.
	"Split divider styles"
 	NSSplitViewDividerStyleThick := 1.
   	NSSplitViewDividerStyleThin := 2.
   	NSSplitViewDividerStylePaneSplitter := 3.
	"TextField bezel style"
	NSTextFieldSquareBezel  := 0.
	NSTextFieldRoundedBezel := 1.
	"Button image position"
 	NSNoImage       			:= 0.
   	NSImageOnly    			:= 1.
   	NSImageLeft     			:= 2.
   	NSImageRight    			:= 3.
   	NSImageBelow    			:= 4.
   	NSImageAbove    			:= 5.
   	NSImageOverlaps 			:= 6	.
	"Segmented control"
	NSSegmentStyleAutomatic 				:= 0.
   	NSSegmentStyleRounded 				:= 1.
   	NSSegmentStyleTexturedRounded 		:= 2.
   	NSSegmentStyleRoundRect 			:= 3.
   	NSSegmentStyleTexturedSquare 		:= 4.
   	NSSegmentStyleCapsule 				:= 5.
   	NSSegmentStyleSmallSquare 			:= 6.
	"Image"
	NSScaleProportionally 					:= 0.
	NSScaleToFit 							:= 1.
	NSScaleNone 							:= 2.
! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeWindowConstants 
	"Window style mask constants"
	NSBorderlessWindowMask 				:= 0.
 	NSTitledWindowMask 					:= 1 << 0.
	NSClosableWindowMask 				:= 1 << 1.
	NSMiniaturizableWindowMask 			:= 1 << 2.
	NSResizableWindowMask 				:= 1 << 3.
	NSTexturedBackgroundWindowMask 	:= 1 << 8.
	"NSBackingStoreType - Buffered Window Drawing"
	NSBackingStoreRetained     			:= 0.
	NSBackingStoreNonretained  			:= 1.
	NSBackingStoreBuffered     			:= 2.
	"Window buttons"
	NSWindowCloseButton 					:= 0.
	NSWindowMiniaturizeButton 			:= 1.
	NSWindowZoomButton 				:= 2.
	NSWindowToolbarButton 				:= 3.
	NSWindowDocumentIconButton 		:= 4.
	"Alert styles"
 	NSWarningAlertStyle 					:= 0.
   	NSInformationalAlertStyle 				:= 1.
   	NSCriticalAlertStyle 					:= 2.
	"Alert buttons"
	NSAlertFirstButtonReturn  				:= 1000.
   	NSAlertSecondButtonReturn  			:= 1001.
   	NSAlertThirdButtonReturn  				:= 1002.! !

!CocoaConstantPool class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
valueOf: varName
	^(self bindingOf: varName) value! !

Object subclass: #CocoaView
	instanceVariableNames: 'externalHandle deferredActions'
	classVariableNames: ''
	poolDictionaries: 'CocoaConstantPool'
	category: 'Mars-Cocoa-View'!

CocoaView subclass: #CocoaContainer
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-View'!

!CocoaContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:19'!
add: aView
	self assert: aView isEmbedable 
		description: 'Just embedable views can be added to a container'.
	
	aView parent: self.
	self children add: aView.
	self embedView: aView.
	
	^aView! !

!CocoaContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:20'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].
	^aCollection! !

!CocoaContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:22'!
children 
	^children ifNil: [ children := OrderedCollection new ]! !

!CocoaContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:36'!
deepPerformDeferredActions 
	super deepPerformDeferredActions.
	self children do: #deepPerformDeferredActions.! !

!CocoaContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:22'!
embedView: aView   
	self externalHandle addSubview: aView externalHandle! !

!CocoaContainer methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/21/2012 15:19'!
initialize 
	super initialize.
	self initializeContents! !

!CocoaContainer methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/21/2012 15:23'!
initializeContents! !

!CocoaContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:21'!
internalRemove: aView   
	aView externalHandle removeFromSuperview.
	self externalHandle setNeedsDisplay: true asAlien! !

!CocoaContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:21'!
internalRemoveAll
	self children do: [ :each | each externalHandle removeFromSuperview ].
! !

!CocoaContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:20'!
remove: aView 
	self children remove: aView.
	self internalRemove: aView.! !

!CocoaContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:21'!
removeAll 
	children := OrderedCollection new.
	self internalRemoveAll! !

CocoaContainer subclass: #CocoaWindow
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-View'!

!CocoaWindow class methodsFor: 'defaults' stamp: 'EstebanLorenzano 1/21/2012 15:25'!
defaultBacking 
	^NSBackingStoreBuffered! !

!CocoaWindow class methodsFor: 'defaults' stamp: 'EstebanLorenzano 1/21/2012 15:25'!
defaultStyleMask 
	^NSTitledWindowMask 
		| NSClosableWindowMask 
		| NSMiniaturizableWindowMask 
		| NSResizableWindowMask
! !

!CocoaWindow methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:28'!
bounds  
	^Rectangle fromNSRect: self externalHandle contentView bounds! !

!CocoaWindow methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 17:11'!
bounds: aRectangle
	self externalHandle
		setFrame: aRectangle translateToFirstQuadrant asNSRect 
		display: true asAlien! !

!CocoaWindow methodsFor: 'showing' stamp: 'EstebanLorenzano 1/21/2012 15:30'!
center 
	self externalHandle center! !

!CocoaWindow methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:23'!
createExternalHandle 
	^'NSWindow' inObjectiveC alloc 
		initWithContentRect: (0@0 corner: 0@0) asNSRect 
		styleMask: self class defaultStyleMask
		backing: self class defaultBacking
		defer: false asAlien! !

!CocoaWindow methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:58'!
delegate 
	^delegate ifNil: [ delegate := CocoaWindowDelegate for: self ]! !

!CocoaWindow methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:30'!
embedView: aView 
	self externalHandle contentView addSubview: aView externalHandle    ! !

!CocoaWindow methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/21/2012 16:18'!
initialize 
	super initialize.
	self externalHandle 
		setDelegate: self delegate externalHandle! !

!CocoaWindow methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:30'!
internalShow 
	self externalHandle makeKeyAndOrderFront: nil asAlien ! !

!CocoaWindow methodsFor: 'testing' stamp: 'EstebanLorenzano 1/21/2012 15:22'!
isEmbedable
	^false! !

!CocoaWindow methodsFor: 'testing' stamp: 'EstebanLorenzano 1/21/2012 17:56'!
isVisible
	^ Boolean fromNumber: self externalHandle isVisible! !

!CocoaWindow methodsFor: 'registering' stamp: 'EstebanLorenzano 1/21/2012 16:20'!
register
	CocoaApplication current registerWindow: self.! !

!CocoaWindow methodsFor: 'showing' stamp: 'EstebanLorenzano 1/21/2012 16:19'!
show 
	"self layoutChanged."
	self deepPerformDeferredActions.
	self register.
	self internalShow! !

!CocoaWindow methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:25'!
title
	^String fromNSString: self externalHandle title! !

!CocoaWindow methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:27'!
title: aString 
	CocoaAutoreleasePool 
		do: [ self externalHandle setTitle: aString asNSString autorelease ]! !

!CocoaWindow methodsFor: 'registering' stamp: 'EstebanLorenzano 1/21/2012 16:20'!
unregister
	CocoaApplication current unregisterWindow: self.! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 16:50'!
bounds 
	^(Rectangle fromNSRect: self externalHandle frame) translateToFourthQuadrant! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 16:50'!
bounds: aRectangle
	"Sets the bounds for a view. 
	 There is a Cocoa design issue for this: the frame of the view is defined referred to it's 
	 parent. For that reason, if the view is not attached to parent, the set of this property
	 is deferrer until the view is attached. 
	 All the views are part of a window, and MRWindow has a diferent logic, so this shouldn't 
	 cause any problem"
	self executeActionOrDeferUntilEmbedded: [ 
		self externalHandle setFrame: aRectangle translateToFirstQuadrant asNSRect ].  ! !

!CocoaView methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 09:28'!
createExternalHandle
	^self subclassResponsibility! !

!CocoaView methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
deepPerformDeferredActions
	self performDeferredActions! !

!CocoaView methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:33'!
executeActionOrDeferUntilEmbedded: aBlock
	"Some actions need to be deferred until the view is embeded. This is because some actions 
	 (for example set bounds related to a parent) needs to have a parent defined before been executed"
	self isEmbedded 
		ifTrue: aBlock
		ifFalse: [ self deferAction: aBlock ]! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:31'!
extent 
	^self bounds extent! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:31'!
extent: aPoint 
	self bounds: (self bounds origin extent: aPoint)! !

!CocoaView methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:21'!
externalHandle 
	^externalHandle! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:31'!
height 
	^self bounds height! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:31'!
height: aNumber 
	^self extent: (self width @ aNumber)! !

!CocoaView methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/21/2012 15:17'!
initialize 
	super initialize.
	externalHandle := self createExternalHandle.! !

!CocoaView methodsFor: 'testing' stamp: 'EstebanLorenzano 1/21/2012 15:22'!
isEmbedable
	^true! !

!CocoaView methodsFor: 'testing' stamp: 'EstebanLorenzano 1/21/2012 15:33'!
isEmbedded 
	^self parent notNil! !

!CocoaView methodsFor: 'testing' stamp: 'EstebanLorenzano 1/21/2012 15:33'!
isRoot 
	^self parent isNil! !

!CocoaView methodsFor: 'testing' stamp: 'EstebanLorenzano 1/21/2012 15:33'!
isView
	^true! !

!CocoaView methodsFor: 'testing' stamp: 'EstebanLorenzano 1/21/2012 15:33'!
isVisible 
	^(Boolean fromNumber: self externalHandle isHidden) not! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
left
	^self position x! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
left: aNumber
	self position: (aNumber @ self top)! !

!CocoaView methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:33'!
performDeferredActions
	"If there is any deferred action waiting to be executed, I perform the task. 
	 I dispose the #deferredActions attribute so the cycle can restart clean"
	deferredActions ifNotNil: [ 
		deferredActions do: #value.
		deferredActions := nil ]! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
position
	^ self bounds bottomLeft! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
position: aPoint
	self bounds: (aPoint extent: self extent)! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
top 
	^self position y! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
top: aNumber
	self position: (self left @ aNumber)! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
width 
	^self bounds width! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
width: aNumber 
	^self extent: (aNumber @ self height)! !
CocoaConstantPool initialize!
